(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

open Term;;
open Equation;;
open Rule;;
open Useful;;

type ers = EqnSet.t * RulSet.t;;

val bprint : ers bprint;;

type 'a gt = 'a -> 'a -> bool;;

exception Unorientable of EqnSet.t;;

(* completion step *)

val step : RulSet.t -> term gt -> ers -> ers;;

(* limited completion. n is the maximal number of completion steps.
rules are assumed oriented by gt *)

val complete_n : RulSet.t -> term gt -> int -> ers -> ers * int;;

(* full completion. may not terminate. rules are assumed oriented by gt *)

val complete : RulSet.t -> term gt -> ers -> ers * int;;
