(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: eqnrel.mli,v 1.4.2.1 2008/02/13 15:54:40 bonichon Exp $ *)

open Parsetree;;
open Term;;
open Equation;;
open Code;;
open Rule;;

exception Not_algebraic;;

(** Convert a set of Moca relations into a set of equations. *)

val eqnset_of_rels : generator -> relations -> EqnSet.t;;

(** Convert a single Moca relation into a set of equations. *)

val eqns_of_rel : generator -> relation -> eqn list;;

(** Convert a term into a Code.exp. *)

val exp_of_term : term -> exp;;

(** Convert a rule into a Code.clause. *)

val clause_of_rule : rule -> clause;;

(** Bounded completion of a type declaration. *)

val completion : int -> (string * type_declaration) list -> unit;;


type ordering =
   | RPO | LPO | MPO
;;

val get_order : unit -> ordering
;;
val set_order : ordering -> unit
;;
