(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* equations *)

open Term;;
open Useful;;

type eqn = term * term;;

(* equality up to renaming *)

val compare : eqn -> eqn -> int;;

(* print an equation into a buffer *)

val bprint : eqn bprint;;

(* useful modules *)

module OrdEqn : ORD_PRT;;

module EqnSet : Myset.S with type elt = eqn;;

val add_non_trivial : (term -> term) -> eqn -> EqnSet.t -> EqnSet.t;;

val remove_trivial : (term -> term) -> EqnSet.t -> EqnSet.t;;

(* test if an equation is commutativity *)

val is_commutativity : eqn -> bool;;

val has_commutativity : EqnSet.t -> bool;;

val remove_commutativity : EqnSet.t -> EqnSet.t;;
