(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* precedences *)

type prec;;

open Symb;;
open Order;;

val compare : prec -> symb cmp;;

val empty : prec;;

(* add a new constraint. raise Failure if it is not compatible *)

val add_lt : prec -> symb -> symb -> prec;;
val add_eq : prec -> symb -> symb -> prec;;
val add_gt : prec -> symb -> symb -> prec;;

(* [f1; ..; fn] gives f1 < .. < fn *)
val prec_of_list : symb list -> prec;;
