(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* term data structure *)

open Var;;
open Symb;;

type term =
  | Var of var
  | App of symb * term list;;

val vars : term -> VarSet.t;;

val vars_of_terms : term list -> VarSet.t;;

val is_linear : term -> bool;;

val symbols : term -> SymbSet.t;;

val symbols_of_terms : term list -> SymbSet.t;;

val occurs : var -> term -> bool;;

val bprint : Buffer.t -> term -> unit;;
